addHook("ThinkFrame", function(player)
    for player in players.iterate
		if P_IsObjectOnGround(player.mo)
		and player.mo.skin == "mint"
		and not player.legacymint == true
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state >= S_PLAY_EDGE)
		and not (player.pflags & PF_SPINNING)
		and not (player.pflags & PF_STARTDASH)
		and not (player.pflags & PF_JUMPED)
		and (R_PointToDist2(0, 0, player.mo.momx, player.mo.momy) >= player.runspeed)
		    local runparticle = P_SpawnMobj(player.mo.x, player.mo.y,
						player.mo.z + ((player.mo.eflags & MFE_VERTICALFLIP)/MFE_VERTICALFLIP * (player.mo.height - mobjinfo[MT_PARTICLE].height)),
						MT_PARTICLE)
					P_InstaThrust(runparticle, player.mo.angle+(P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT), FixedMul(-player.dashspeed/12-1*FRACUNIT-P_RandomByte()<<11, player.mo.scale))
					P_TryMove(runparticle, runparticle.x+runparticle.momx, runparticle.y+runparticle.momy, true)
					P_SetObjectMomZ(runparticle, 8*FRACUNIT, true)

			    runparticle.fuse = 6
				runparticle.frame = TR_TRANS50
		end
	end
end)